/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.18 from the
 * contents of XSHeaders.xs. Do not edit this file, edit XSHeaders.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XSHeaders.xs"
#define PERL_NO_GET_CONTEXT     /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include "glog.h"
#include "gmem.h"
#include "util.h"
#include "header.h"

#if defined(USE_ITHREADS) && !defined(sv_dup_inc)
# define sv_dup_inc(sv, param) SvREFCNT_inc(sv_dup(sv, param))
#endif

#ifndef PERL_UNUSED_ARG
# define PERL_UNUSED_ARG(x) ((void)x)
#endif

static MAGIC* THX_mg_find(pTHX_ SV* sv, const MGVTBL* const vtbl) {
    MAGIC* mg;

    if (SvTYPE(sv) < SVt_PVMG)
      return NULL;

    for (mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic) {
      if(mg->mg_virtual == vtbl)
        return mg;
    }
    return NULL;
}

static int THX_mg_free(pTHX_ SV* const sv, MAGIC* const mg) {
  HList* const hl = (HList*)mg->mg_ptr;
  int j, k;

  GLOG(("=X= @@@ mg_free(%p|%d)", hl, hlist_size(hl)));

  for (j = 0; j < hl->ulen; ++j) {
    HNode* hn = &hl->data[j];
    PList* pl = hn->values;
    for (k = 0; k < pl->ulen; ++k) {
      PNode* pn = &pl->data[k];
      SvREFCNT_dec((SV*)pn->ptr);
    }
  }

  hlist_destroy(hl);
  return 0;
}

static int THX_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param) {
#ifdef USE_ITHREADS
  HList* const hl = (HList*)mg->mg_ptr;
  HList* clone;
  int j, k;

  GLOG(("=X= @@@ mg_dup(%p|%d)", hl, hlist_size(hl)));

  if (!(clone = hlist_clone(hl)))
    croak("Could not clone HList object");

  for (j = 0; j < clone->ulen; ++j) {
    HNode* hnode = &clone->data[j];
    PList* plist = hnode->values;
    for (k = 0; k < plist->ulen; ++k) {
      PNode* pnode = &plist->data[k];
      pnode->ptr = sv_dup_inc((SV*)pnode->ptr, param);
    }
  }
  mg->mg_ptr = (char *)clone;
#else
  PERL_UNUSED_ARG(mg);
  PERL_UNUSED_ARG(param);
#endif
  return 0;
}

static MGVTBL const hlist_mgvtbl = {
    NULL,        /* get */
    NULL,        /* set */
    NULL,        /* len */
    NULL,        /* clear */
    THX_mg_free, /* free */
    NULL,        /* copy */
    THX_mg_dup,  /* dup */
#ifdef MGf_LOCAL
    NULL,        /* local */
#endif
};

static SV * THX_newSV_HList(pTHX_ HList* const hl, HV * const stash) {
  MAGIC *mg;
  HV *hv;
  SV *rv;

  GLOG(("=X= Will bless new object"));

  hv = newHV();
  rv = newRV_noinc((SV*)hv);
  mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &hlist_mgvtbl, (char *)hl, 0);
  mg->mg_flags |= MGf_DUP;
  sv_bless(rv, stash);
  sv_2mortal(rv);
  return rv;
}

static HList * THX_sv_2HList(pTHX_ SV* const sv, const char *name) {
  MAGIC* mg = NULL;

  SvGETMAGIC(sv);
  if (SvROK(sv))
    mg = THX_mg_find(aTHX_ SvRV(sv), &hlist_mgvtbl);

  if (!mg)
    croak("%s is not an instance of HTTP::XSHeaders", name);

  return (HList*)mg->mg_ptr;
}

#define newSV_HList(hl, stash) \
  THX_newSV_HList(aTHX_ hl, stash)

#define sv_2HList(sv, name) \
  THX_sv_2HList(aTHX_ sv,  name)

#line 136 "XSHeaders.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 278 "XSHeaders.c"

XS_EUPXS(XS_HTTP__XSHeaders_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "klass, ...");
    {
#line 136 "XSHeaders.xs"
    int    argc = 0;
    HList* hl = 0;
    int    j;
    SV*    pkey;
    SV*    pval;
    char*  ckey;

#line 295 "XSHeaders.c"
	SV*	klass = ST(0)
;
#line 144 "XSHeaders.xs"
    if (!SvOK(klass) || !SvPOK(klass)) {
      XSRETURN_EMPTY;
    }

    argc = items - 1;
    if ( argc % 2 ) {
      croak("Expecting a hash as input to constructor");
    }

    GLOG(("=X= @@@ new()"));
    if (!(hl = hlist_create()))
      croak("Could not create new HList object");

    ST(0) = newSV_HList(hl, gv_stashpv(SvPV_nolen(klass), 0));

    /* create the initial list */
    for (j = 1; j <= argc; ) {
      pkey = ST(j++);

      /* did we reach the end by any chance? */
      if (j > argc) {
        break;
      }

      pval = ST(j++);
      ckey = SvPV_nolen(pkey);
      GLOG(("=X= Will set [%s] to [%s]", ckey, SvPV_nolen(pval)));
      set_value(aTHX_ hl, ckey, pval);
    }
    XSRETURN(1);
#line 329 "XSHeaders.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_HTTP__XSHeaders_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hl");
    {
#line 179 "XSHeaders.xs"
    HList* clone;
    int    j;
    int    k;
#line 346 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 183 "XSHeaders.xs"
    GLOG(("=X= @@@ clone(%p|%d)", hl, hlist_size(hl)));

    if (!(clone = hlist_clone(hl)))
      croak("Could not clone HList object");

    ST(0) = newSV_HList(clone, SvSTASH(SvRV(ST(0))));

    /* Clone the SVs into new ones */
    for (j = 0; j < clone->ulen; ++j) {
      HNode* hnode = &clone->data[j];
      PList* plist = hnode->values;
      for (k = 0; k < plist->ulen; ++k) {
        PNode* pnode = &plist->data[k];
        pnode->ptr = newSVsv( (SV*)pnode->ptr );
      }
    }

    XSRETURN(1);
#line 368 "XSHeaders.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_HTTP__XSHeaders_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_clear)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    {
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 209 "XSHeaders.xs"
    GLOG(("=X= @@@ clear(%p|%d)", hl, hlist_size(hl)));
    hlist_clear(hl);
#line 386 "XSHeaders.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_HTTP__XSHeaders_header_field_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_header_field_names)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hl");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 219 "XSHeaders.xs"
    GLOG(("=X= @@@ header_field_names(%p|%d), want %d",
          hl, hlist_size(hl), GIMME_V));
    hlist_sort(hl);
    PUTBACK;
    return_hlist(aTHX_ hl, "header_field_names", GIMME_V);
    SPAGAIN;
#line 410 "XSHeaders.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_HTTP__XSHeaders_init_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_init_header)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    {
#line 233 "XSHeaders.xs"
    int    argc = 0;
    SV*    pkey;
    SV*    pval;
    STRLEN len;
    char*  ckey;

#line 431 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 240 "XSHeaders.xs"
    GLOG(("=X= @@@ init_header(%p|%d), %d params, want %d",
          hl, hlist_size(hl), argc, GIMME_V));
    argc = items - 1;
    if (argc != 2) {
      croak("init_header needs two arguments");
    }

    /* TODO: apply this check everywhere! */
    pkey = ST(1);
    if (!SvOK(pkey) || !SvPOK(pkey)) {
      croak("init_header not called with a first string argument");
    }
    ckey = SvPV(pkey, len);
    pval = ST(2);

    if (!hlist_get(hl, ckey)) {
      set_value(aTHX_ hl, ckey, pval);
    }
#line 453 "XSHeaders.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_HTTP__XSHeaders_push_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_push_header)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    {
#line 265 "XSHeaders.xs"
    int    argc = 0;
    int    j;
    SV*    pkey;
    SV*    pval;
    STRLEN len;
    char*  ckey;

#line 474 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 273 "XSHeaders.xs"
    GLOG(("=X= @@@ push_header(%p|%d), %d params, want %d",
          hl, hlist_size(hl), argc, GIMME_V));

    argc = items - 1;
    if (argc % 2 != 0) {
      croak("push_header needs an even number of arguments");
    }

    for (j = 1; j <= argc; ) {
        if (j > argc) {
          break;
        }
        pkey = ST(j++);

        if (j > argc) {
          break;
        }
        pval = ST(j++);

        ckey = SvPV(pkey, len);
        set_value(aTHX_ hl, ckey, pval);
    }
#line 500 "XSHeaders.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_HTTP__XSHeaders_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_header)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 303 "XSHeaders.xs"
    int    argc = 0;
    int    j;
    SV*    pkey = 0;
    SV*    pval = 0;
    STRLEN len;
    char*  ckey = 0;
    HNode* n = 0;
    HList* seen = 0; /* TODO: make this more efficient; use Perl hash? */

#line 525 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 313 "XSHeaders.xs"
    GLOG(("=X= @@@ header(%p|%d), %d params, want %d",
          hl, hlist_size(hl), argc, GIMME_V));

    argc = items - 1;
    do {
      if (argc == 0) {
        croak("header called with no arguments");
      }

      if (argc == 1) {
        pkey = ST(1);
        ckey = SvPV(pkey, len);
        n = hlist_get(hl, ckey);
        if (n && plist_size(n->values) > 0) {
          PUTBACK;
          return_plist(aTHX_ n->values, "header1", GIMME_V);
          SPAGAIN;
        }
        break;
      }

      if (argc % 2 != 0) {
        croak("init_header needs one or an even number of arguments");
      }

      seen = hlist_create();
      for (j = 1; j <= argc; ) {
          if (j > argc) {
            break;
          }
          pkey = ST(j++);

          if (j > argc) {
            break;
          }
          pval = ST(j++);

          ckey = SvPV(pkey, len);
          int clear = 0;
          if (! hlist_get(seen, ckey)) {
            clear = 1;
            hlist_add(seen, ckey, 0);
          }

          n = hlist_get(hl, ckey);
          if (n) {
            if (j > argc && plist_size(n->values) > 0) {
              /* Last value, return its current contents */
              PUTBACK;
              return_plist(aTHX_ n->values, "header2", GIMME_V);
              SPAGAIN;
            }
            if (clear) {
              plist_clear(n->values);
            }
          }

          set_value(aTHX_ hl, ckey, pval);
      }
      hlist_destroy(seen);
      break;
    } while (0);
#line 591 "XSHeaders.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_HTTP__XSHeaders__header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders__header)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 388 "XSHeaders.xs"
    int    argc = 0;
    SV*    pkey = 0;
    STRLEN len;
    char*  ckey = 0;
    HNode* n = 0;

#line 614 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 395 "XSHeaders.xs"
    GLOG(("=X= @@@ header(%p|%d), %d params, want %d",
          hl, hlist_size(hl), argc, GIMME_V));

    argc = items - 1;
    if (argc != 1) {
      croak("_header not called with one argument");
    }

    pkey = ST(1);
    if (!SvOK(pkey) || !SvPOK(pkey)) {
      croak("_header not called with one string argument");
    }
    ckey = SvPV(pkey, len);
    n = hlist_get(hl, ckey);
    if (n && plist_size(n->values) > 0) {
      PUTBACK;
      return_plist(aTHX_ n->values, "_header", GIMME_V);
      SPAGAIN;
    }
#line 637 "XSHeaders.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_HTTP__XSHeaders_remove_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_remove_header)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 422 "XSHeaders.xs"
    int    argc = 0;
    int    j;
    SV*    pkey;
    STRLEN len;
    char*  ckey;
    int    size = 0;
    int    total = 0;

#line 662 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 431 "XSHeaders.xs"
    GLOG(("=X= @@@ remove_header(%p|%d), %d params, want %d",
          hl, hlist_size(hl), argc, GIMME_V));

    argc = items - 1;
    for (j = 1; j <= argc; ++j) {
      pkey = ST(j);
      ckey = SvPV(pkey, len);

      HNode* n = hlist_get(hl, ckey);
      if (!n) {
        continue;
      }

      size = plist_size(n->values);
      if (size > 0) {
        total += size;
        if (GIMME_V == G_ARRAY) {
          PUTBACK;
          return_plist(aTHX_ n->values, "remove_header", G_ARRAY);
          SPAGAIN;
        }
      }

      hlist_del(hl, ckey);
      GLOG(("=X= remove_header: deleted key [%s]", ckey));
    }

    if (GIMME_V == G_SCALAR) {
      GLOG(("=X= remove_header: returning count %d", total));
      EXTEND(SP, 1);
      PUSHs(sv_2mortal(newSViv(total)));
    }
#line 698 "XSHeaders.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_HTTP__XSHeaders_remove_content_headers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_remove_content_headers)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    {
#line 471 "XSHeaders.xs"
    HList* to = 0;
    HNode* n = 0;
    int    j;

#line 717 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 476 "XSHeaders.xs"
    GLOG(("=X= @@@ remove_content_headers(%p|%d)",
          hl, hlist_size(hl)));

    if (!(to = hlist_create()))
      croak("Could not create new HList object");

    ST(0) = newSV_HList(to, SvSTASH(SvRV(ST(0))));

    for (j = 0; j < hl->ulen; ) {
      n = &hl->data[j];
      if (! header_is_entity(n->header)) {
        ++j;
        continue;
      }
      hlist_transfer_header(hl, j, to);
    }

    XSRETURN(1);
#line 739 "XSHeaders.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_HTTP__XSHeaders_as_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_as_string)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    {
#line 499 "XSHeaders.xs"
    char* str = 0;
    int size = 0;

#line 756 "XSHeaders.c"
	const char *	RETVAL;
	dXSTARG;
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 503 "XSHeaders.xs"
    GLOG(("=X= @@@ as_string(%p|%d) %d", hl, hlist_size(hl), items));

    const char* cendl = "\n";
    if ( items > 1 ) {
      SV* pendl = ST(1);
      cendl = SvPV_nolen(pendl);
    }

    str = format_all(aTHX_ hl, 1, cendl, &size);
    RETVAL = str;

#line 773 "XSHeaders.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 517 "XSHeaders.xs"
    GMEM_DEL(str, char*, size);
#line 777 "XSHeaders.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_HTTP__XSHeaders_as_string_without_sort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_as_string_without_sort)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "hl, ...");
    {
#line 523 "XSHeaders.xs"
    char* str = 0;
    int size = 0;

#line 794 "XSHeaders.c"
	const char *	RETVAL;
	dXSTARG;
	HList*  hl = sv_2HList(ST(0), "hl")
;
#line 527 "XSHeaders.xs"
    GLOG(("=X= @@@ as_string_without_sort(%p|%d) %d", hl, hlist_size(hl), items));

    const char* cendl = "\n";
    if ( items > 1 ) {
      SV* pendl = ST(1);
      cendl = SvPV_nolen(pendl);
    }

    str = format_all(aTHX_ hl, 0, cendl, &size);
    RETVAL = str;

#line 811 "XSHeaders.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 541 "XSHeaders.xs"
    GMEM_DEL(str, char*, size);
#line 815 "XSHeaders.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_HTTP__XSHeaders_scan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSHeaders_scan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hl, sub");
    {
#line 547 "XSHeaders.xs"
    int j;
    int k;

#line 832 "XSHeaders.c"
	HList*  hl = sv_2HList(ST(0), "hl")
;
	SV*	sub = ST(1)
;
#line 551 "XSHeaders.xs"
    GLOG(("=X= @@@ scan(%p|%d)", hl, hlist_size(hl)));

    if (!SvOK(sub) || !SvRV(sub) || SvTYPE( SvRV(sub) ) != SVt_PVCV ) {
      croak("Second argument must be a CODE reference");
    }

    hlist_sort(hl);
    for (j = 0; j < hl->ulen; ++j) {
      HNode* hn = &hl->data[j];
      const char* header = hn->header->name;
      SV* pheader = sv_2mortal(newSVpv(header, 0));
      PList* pl = hn->values;
      for (k = 0; k < pl->ulen; ++k) {
        PNode* pn = &pl->data[k];
        SV* value = (SV*) pn->ptr;

        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        PUSHs( pheader );
        PUSHs( value );
        PUTBACK;
        call_sv( (SV *)SvRV(sub), G_DISCARD );

        FREETMPS;
        LEAVE;
      }
    }
#line 867 "XSHeaders.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_HTTP__XSHeaders); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_HTTP__XSHeaders)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("HTTP::XSHeaders::new", XS_HTTP__XSHeaders_new, file);
        newXS("HTTP::XSHeaders::clone", XS_HTTP__XSHeaders_clone, file);
        newXS("HTTP::XSHeaders::clear", XS_HTTP__XSHeaders_clear, file);
        newXS("HTTP::XSHeaders::header_field_names", XS_HTTP__XSHeaders_header_field_names, file);
        newXS("HTTP::XSHeaders::init_header", XS_HTTP__XSHeaders_init_header, file);
        newXS("HTTP::XSHeaders::push_header", XS_HTTP__XSHeaders_push_header, file);
        newXS("HTTP::XSHeaders::header", XS_HTTP__XSHeaders_header, file);
        newXS("HTTP::XSHeaders::_header", XS_HTTP__XSHeaders__header, file);
        newXS("HTTP::XSHeaders::remove_header", XS_HTTP__XSHeaders_remove_header, file);
        newXS("HTTP::XSHeaders::remove_content_headers", XS_HTTP__XSHeaders_remove_content_headers, file);
        newXS("HTTP::XSHeaders::as_string", XS_HTTP__XSHeaders_as_string, file);
        newXS("HTTP::XSHeaders::as_string_without_sort", XS_HTTP__XSHeaders_as_string_without_sort, file);
        newXS("HTTP::XSHeaders::scan", XS_HTTP__XSHeaders_scan, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

